#include include\commctrl.h

local x

If .f.
x=CreateObject("VFPBar")
With x
	_vfp.StatusBar=' ...'

	.show()
	n=10000
	For i=1 to n
		x.value(i/n)
	Next
	n=10000
	For i=n to 1 step -1
		x.value(i/n)
	Next

	_vfp.StatusBar=' '
EndWith

Return
endif

x=CreateObject("My")
x.show
For i=1 to 100000
	x.bar.value(i/100000)
Next


Define class my as Form


	Add object bar as progressbar
	
	Add object ani as animation


	Procedure init
	With this
		.BackColor=-1
	
		.Bar.Visible=.T.
		.Bar.Top=4
		.Bar.Left=4
		.Bar.Height=18
		.Bar.Width=289

		.Ani.Top=20
		.Ani.Left=20

		.Bar.ParentHWND=.Bar.VFPStatusHWND()

		.Ani.Show()
		
		.Ani.Play(160,"videos.dll")
		
		.Bar.Show()

		
	EndWith

EndDefine

Define Class Animation as Commctrl
	ClassName=ANIMATE_CLASS
	Width=32
	Height=32
	Top=10
	Left=10

	Library=0
	
	Style=ACS_AUTOPLAY &&+ACS_TRANSPARENT &&ACS_TIMER
		
	Procedure Play( m.File, m.Library)
	With this
		If not Empty(m.Library)
			.Library=LoadLibraryEx(m.Library,0,LOAD_LIBRARY_AS_DATAFILE)
			.SendMessage(ACM_OPENA,.Library,@m.file)
		Else
			.SendMessage(ACM_OPENA,0,@m.file)
		endif
	EndWith

	Procedure Stop
	With this
		.SendMessage(ACM_STOP,0,0)
	EndWith

	Procedure Destroy
	With this
		If .Library # 0
			FreeLibrary(.Library)
		endif
		DoDefault()
	EndWith

EndDefine


Define Class VFPBar as ProgressBar

	Procedure Show(oForm)
	With this
		Local x
		x=110
		x=x+Iif(_Screen.WindowState=0,18,0)
		x=x+Iif(Set("Clock")="STATUS",30,0)
		.Top=4
		.Height=17
		.Width=289
		.Left=_Vfp.Width -.Width-x
		.ParentHWND=.VFPStatusHWND()
		DoDefault(oForm)
	EndWith

EndDefine

Define Class ProgressBar as CommCtrl
	ClassName=PROGRESS_CLASS
	
	Width=350
	Height=18
	
	Min=0
	Max=100
	Step=0
*	BackColor=0
*	BarColor=0

	Visible=.T.

	Procedure Show(oForm)
	With this
		DoDefault(oForm)
		.Min=.Min
		.Max=.Max
	EndWith
	
		
	Procedure Min_Assign(val)
	With this
		.Min=Val
		.SendMessage(PBM_SETRANGE32,.Min,.Max)
	EndWith 

	Procedure Max_Assign(val)
	With this
		.Max=Val
		.SendMessage(PBM_SETRANGE32,.Min,.Max)
	EndWith 

	Procedure SetStep(nStep)
	With this
		.Step=nStep
		.SendMessage(PBM_SETSTEP,.Step)
	EndWith 
	
	Procedure Clear
	With this
		.SendMessage(PBM_DELTAPOS,0,0)
	EndWith 

	Procedure StepIp
	With this
		.SendMessage(PBM_STEPIT,0,0)
	EndWith 
		
	Procedure BackColor(nColor)
	With this
		.SendMessage(PBM_SETBKCOLOR,0,nColor)
	EndWith 
	
	Procedure BarColor(nColor)
	With this
		.SendMessage(PBM_SETBARCOLOR,0,nColor)
	EndWith 

	Procedure Value(nValue)
	With this
		nValue=nValue*100
		If Between(nValue,.Min,.Max)
			.SendMessage(PBM_SETPOS,nValue,0)
		endif
	EndWith

	Procedure VFPStatusHwnd
	With this
		If Set("Status Bar")="ON"
			Local x, buf, t,l,r,b
			buf=Replicate(Chr(0),16)
			GetClientRect(_vfp.hWnd,@buf)

			l=.C2B(Substr(buf,1,4))
			t=.C2B(Substr(buf,5,4))
			r=.C2B(Substr(buf,9,4))
			b=.C2B(Substr(buf,13,4))

			x=ChildWindowFromPoint(_vfp.hWnd,0,b-t-1)
			Return x
		EndIf
		Return 0
	EndWith


EndDefine


Define Class CommCtrl as Custom
	Visible=.T.
	ClassName=""

	ThisHWND=0
	ParentHWND=0
		
	Style=0
	
	Procedure Init
	With this
		.LoadDLLS()
	EndWith

	Procedure Show(oForm)
	With this
		.CreateWindow(oForm)
	EndWith

	Procedure CreateWindow(oParentForm)
	With this
		If not Empty(.ThisHWND)
			DestroyWindow(.ThisHWND)
		EndIf
		.GetParentHWND(oParentForm)

		nInstance=GetWindowLong( .ParentHWND, GWL_HINSTANCE)
		
		.ThisHWND=CreateWindowEx;
			(WS_EX_NOPARENTNOTIFY;
			,.ClassName;
			,.Name;
			, WS_CHILD+WS_VISIBLE+.Style;
			,.Left;
			,.Top;
			,.Width;
			,.Height;
			,.ParentHWND;
			,0;
			,nInstance;
			,0)
	
	EndWith

	Procedure GetParentHWND(oForm)
	With this
		If Empty(.ParentHWND)
			If Vartype(oForm)='O'
				.ParentHWND=oForm.HWND
			Else
				.ParentHWND=ThisForm.HWND
			EndIf
		EndIf
		Return .ParentHWND	
	endwith

	Procedure SendMessage( Msg, lParam, wParam )
	With this
		If not Empty(.ThisHWND)
			If Vartype(wParam)="C"
				SendString(.ThisHWND,Msg,lParam, wParam)
			Else
				SendMessage(.ThisHWND,Msg,lParam, wParam)
			EndIf 
		endif
	EndWith

	Procedure Destroy
	With this
		If not Empty(.ThisHWND)
			DestroyWindow(.ThisHWND)
		EndIf
	EndWith

	Procedure C2B( m.str)
	Local n, i
	n=0
	For i=Len(m.str) to 1 step -1
		n=BitLshift(n,8)+Asc(Substr(m.str,i,1))
	Next
	Return n

	
	Procedure LoadDLLS
	Declare Integer LoadLibraryEx In Win32API ;
	String @ lpFileName, ;	&& file name of module
	Integer hFile, ;		&& reserved, must be NULL
	Integer dwFlags			&& entry-point execution option

	Declare Integer FreeLibrary In Win32API ;
			Integer hModule			&& handle to DLL module

	Declare Integer ChildWindowFromPoint In Win32API ;
			Integer	hWndParent, ;	&& handle to parent window
			Integer	nX, ;
			Integer nY

	Declare Integer SetParent In Win32API ;
			Integer, ;				&& handle to window
			Integer					&& new parent window

	Declare Integer CreateWindowEx In user32 ;
		    Integer	dwExStyle, ;	&& extended window style
			String @lpClassName, ;	&& address of registered class name
		    String @lpWindowName, ;	&& address of window name
	    	Long	dwStyle, ;		&& window style
		    Integer	x, ;			&& horizontal position of window
	    	Integer	y, ;			&& vertical position of window
		    Integer	nWidth,	;		&& window width
	    	Integer nHeight, ;		&& window height
		    Integer hWndParent, ;	&& handle of parent or owner window
	    	Integer	hMenu, ;		&& handle of menu or child-window identifier
		    Integer	hInstance, ;	&& handle of application instance
	    	Long	lpParam 		&& address of window-creation data

	Declare Integer	IsWindow In Win32API ;
			Integer	hWnd 			&& handle of window

	Declare Integer DestroyWindow In Win32API ;
			Integer hWnd			&& handle of window to destroy  

	Declare Integer	SendMessage In Win32API ;
		    Integer	hwnd,;			&& handle of destination window
	    	Integer	uMsg, ;			&& message to send
		    Integer	wParam,;		&& first message parameter
	    	Long	lParam 			&& second message parameter

	Declare Integer ShowWindow In Win32API ;
			Integer	hwnd, ;			&& handle of window
			Integer	nCmdShow		&& show state of window

	Declare Integer SetFocus In Win32API ;
			Integer hWnd

	Declare Integer GetFocus In Win32API

	Declare Integer GetLastError In Win32API

	Declare Long GetWindowLong In Win32API ;
			Integer	hWnd, ;			&& handle of window
			Integer	nIndex			&& offset of value to retrieve

	Declare Integer GetClientRect in Win32Api ;
			Integer hWnd,;
			String @ rect 


	Declare Integer	SendMessage In Win32API ;
		    Integer	hwnd,;			&& handle of destination window
	    	Integer	uMsg, ;			&& message to send
		    Integer	wParam,;		&& first message parameter
	    	Long	lParam 			&& second message parameter

	Declare Integer	SendMessage In Win32API as SendString ;
		    Integer	hwnd,;			&& handle of destination window
	    	Integer	uMsg, ;			&& message to send
		    Integer	wParam,;		&& first message parameter
	    	String @ lParam 		&& second message parameter

EndDefine

