*:********************************************************************
*:
*: Procedure file :app.prg
*:
*: (c) Piva, BEAR v.43 on 13.05.2003 12:52
*:********************************************************************
*  
* --------------------
*


#include Include/Main.h

*:********************************************************************
*:
*: Procedure : ReportsSelection
*:
*:********************************************************************
Procedure ReportsSelection(nBar)
If Vartype(ROOT_OBJECT)=T_OBJECT
	If Vartype(ROOT_OBJECT.Reports)='O'
		ROOT_OBJECT.Reports.Selection(nBar)
	Else
		Messagebox(" ",48,MYTITLE)
	Endif
Else
	Messagebox(" .",48,MYTITLE)
Endif

*:********************************************************************
*:
*: Procedure : GetNewDocumentNumber
*:
*:********************************************************************
Procedure GetNewDocumentNumber( cAlias, oRecord )
If Empty(oRecord.OwnerID)
	Return 0
Endif
Local tmp[1]
Private m.Date, m.OwnerID, m.DateField
m.Date=oRecord.Date
m.DateField='DATE'
m.OwnerID=oRecord.OwnerID

Select Max(Number) ;
	from (cAlias) ;
	where OwnerID=m.OwnerID;
	and Year(&DateField)=Year(m.Date) ;
	and Not Empty(Number);
	and Not Deleted() ;
	into Array tmp

Return Iif(_Tally=0,0,tmp[1])+1

*:********************************************************************
*:
*: Procedure : CheckDocumentNumber
*:
*:********************************************************************
Procedure CheckDocumentNumber( cAlias, oRecord, lMakeNew )
If Empty(oRecord.OwnerID)
	Return .F.
Endif
Local tmp[1]
Private m.Date, m.OwnerID, m.DateField, m.Number, m.DocID
m.Number=oRecord.Number
m.Date=oRecord.Date
m.DateField='DATE'
m.OwnerID=oRecord.OwnerID
m.DocID=oRecord.DocID

Select Count(*) ;
	from (cAlias) ;
	where OwnerID=m.OwnerID;
	and Number=m.Number ;
	and DocID # m.DocID ;
	and Year(&DateField)*100+Month(&DateField)=Year(m.Date)*100+Month(m.Date) ;
	and Not Deleted() ;
	into Array tmp

If Not Empty(m.Number) And tmp[1]=0
	Return .T.
Endif
If Not Empty(lMakeNew)
	oRecord.Number=GetNewDocumentNumber(cAlias,oRecord)
Else
	Return .F.
Endif


*:********************************************************************
*:
*: Procedure : Admin
*:
*:********************************************************************
Procedure Admin
Return .T.

*:********************************************************************
*:
*: Procedure : WriteLog
*:
*:********************************************************************
Procedure WriteLog( oRecord, cEvent )
If Inlist(Type('oRecord.Log'),"C","M")
	oRecord.Log=oRecord.Log+Iif(Empty(oRecord.Log),"",CRLF)+cEvent+";"+;
		_UserID+";"+_UserMachine+";"+;
		Transform(Ttoc(Datetime(),1),'@R 9999-99-99 99:99:99')
Endif

*:********************************************************************
*:
*: Procedure : Amount
*:
*:********************************************************************
Procedure Amount(m.Amount)
Return Alltrim(Transform(m.Amount,_PIC_AMOUNT))

*:********************************************************************
*:
*: Procedure : Price
*:
*:********************************************************************
Procedure Price(m.Price)
Return Alltrim(Transform(m.Price,_PIC_PRICE))

*:********************************************************************
*:
*: Procedure : Number
*:
*:********************************************************************
Procedure Number(m.Number)
Return Alltrim(Transform(m.Number,_PIC_NUMBER))

*:********************************************************************
*:
*: Procedure : Caption
*:
*:********************************************************************
Procedure Caption(m.Number,m.Date)
Return " "+Number(m.Number)+"  "+DateFormat(m.Date,'dd MMMM yyyy .')


*:********************************************************************
*:
*: Procedure : GetBatchSales
*:
*:********************************************************************
Procedure GetBatchSales( m.Batch, m.OwnerID )
*   
Local m.MinOwner, m.MaxOwner, tmp[1]
If Empty(m.Batch)
	Return 0
Endif
If Empty(m.OwnerID)
	m.MinOwner=C_MIN_UNIQUEID
	m.MaxOwner=C_MAX_UNIQUEID
Else
	Store m.OwnerID To m.MinOwner, m.MaxOwner
Endif

Select Sum(InvData.Amount) From InvData, Invoice ;
	Where InvData.Batch=m.Batch ;
	and Invoice.DocID=InvData.DocID ;
	and Invoice.OwnerID Between m.MinOwner And m.MaxOwner ;
	and Not Invoice.Archive ;
	into Array tmp

Return Iif(_Tally=0,0,tmp[1])

*:********************************************************************
*:
*: Procedure : NewBatch
*:
*:********************************************************************
Procedure NewBatch
*   
Local tmp[1]
Set Deleted Off
Select Max(Batch) From SupData Into Array tmp
Set Deleted On
Return Iif(_Tally=0,0,tmp[1])+1


*:********************************************************************
*:
*: Procedure : CanSupplyBeReserved
*:
*:********************************************************************
Procedure CanSupplyBeReserved(m.DocID)
*      
Local tmp[1]

Select InvData.Batch, InvData.Amount ;
	from InvData, Invoice, SupData, Item ;
	Where Invoice.DocID=InvData.DocID ;
	and Not Invoice.Archive ;
	and SupData.Batch=InvData.Batch ;
	and SupData.DocID=m.DocID ;
	and Item.ItemID=InvData.ItemID ;
	and Not Item.Unlimited ;
	into Array tmp

Return _Tally=0


*:********************************************************************
*:
*: Procedure : GetCustomerBalance
*:
*:********************************************************************
Procedure GetCustomerBalance(m.CustID,m.DateMax,m.OwnerID)
*    
*
*
If Empty(m.CustID)
	Return 0
Endif
m.DateMax=Iif(Empty(m.DateMax),{},m.DateMax)
If Empty(m.OwnerID)
	m.MinOwner=C_MIN_UNIQUEID
	m.MaxOwner=C_MAX_UNIQUEID
Else
	Store m.OwnerID To m.MinOwner, m.MaxOwner
Endif

Local m.Ret, tmp[1]
m.Ret=0

*   

Select Saldo From Customer Where CustID=m.CustID Into Array tmp
m.Ret=Iif(_Tally=0,0,tmp[1])

*   

Select Sum(Total) From Supply ;
	where CustID=m.CustID ;
	and Date < m.DateMax ;
	and OwnerID Between m.MinOwner And m.MaxOwner ;
	and Not DocType=SUP_REST ;
	and Not Archive ;
	into Array tmp

m.Ret=m.Ret-Iif(_Tally=0,0,tmp[1])

*   

Select Sum(Total) From Invoice ;
	where CustID=m.CustID ;
	and Date < m.DateMax ;
	and OwnerID Between m.MinOwner And m.MaxOwner ;
	and Not Archive ;
	into Array tmp

m.Ret=m.Ret+Iif(_Tally=0,0,tmp[1])

*    

Select Sum(Total) From Order ;
	where CustID=m.CustID ;
	and Date < m.DateMax ;
	and OwnerID Between m.MinOwner And m.MaxOwner ;
	and Not Archive ;
	into Array tmp

m.Ret=m.Ret-Iif(_Tally=0,0,tmp[1])

*   

Select Sum(Total) From Payment ;
	where CustID=m.CustID ;
	and Date < m.DateMax ;
	and OwnerID Between m.MinOwner And m.MaxOwner ;
	and Not Archive ;
	into Array tmp

m.Ret=m.Ret+Iif(_Tally=0,0,tmp[1])

Return m.Ret

*:********************************************************************
*:
*: Procedure : GetItemBalance
*:
*:********************************************************************
Procedure GetItemBalance(m.ItemID, m.DateMax,m.OwnerID )
If Empty(m.ItemID)
	Return 0
Endif
m.DateMax=Iif(Empty(m.DateMax),{},m.DateMax)
If Empty(m.OwnerID)
	m.MinOwner=C_MIN_UNIQUEID
	m.MaxOwner=C_MAX_UNIQUEID
Else
	Store m.OwnerID To m.MinOwner, m.MaxOwner
Endif

Local m.Ret, tmp[1]
m.Ret=0

Select Sum(SupData.Amount) From SupData, Supply ;
	where SupData.ItemID=m.ItemID ;
	and Supply.DocID=SupData.DocID ;
	and Supply.Date < m.DateMax ;
	and Supply.OwnerID Between m.MinOwner And m.MaxOwner ;
	and Not Supply.DocType = SUP_RESERVED ;
	and Not Supply.Archive ;
	into Array tmp

m.Ret=Iif(_Tally=0,0,tmp[1])

Select Sum(InvData.Amount) From InvData, Invoice ;
	where InvData.ItemID=m.ItemID ;
	and Invoice.DocID=InvData.DocID ;
	and Invoice.Date < m.DateMax ;
	and Invoice.OwnerID Between m.MinOwner And m.MaxOwner ;
	and Not Invoice.DocType = INV_RESERVED ;
	and Not Invoice.Archive ;
	into Array tmp

m.Ret=m.Ret-Iif(_Tally=0,0,tmp[1])

Return m.Ret


*: End of app.prg
