*
*      
*

#include include/main.h


Define Class Storage as Dual
	Caption=''
	FaceMask=FACE_VIEW

	Procedure TreeGrid(oGrid)
	With oGrid
		ROOT_OBJECT.Part.Grid(oGrid)
	EndWith
	
	Procedure ListGrid(oGrid)
	With oGrid
		ROOT_OBJECT.Item.Grid(oGrid)
	EndWith

	Procedure ParentObject_Access
	With this
		If .ActiveControl.Name='Grid'
			DO case
			Case .ActiveControl.RecordSource=.TreeAlias
				Return ROOT_OBJECT.Part
			Case .ActiveControl.RecordSource=.ListAlias
				Return ROOT_OBJECT.Item
			Otherwise
				Return .null.
			EndCase
		EndIf
	EndWith

EndDefine

Define Class Dual as Form
	Caption='Dual Test window'
	Icon=_Screen.Icon
	KeyPreview=.T.
	MDIForm =.T.

	MinWidth=120
	MinHeight=80

	ParentObject=.null.
	ClsID=""
	Escaped=.T.

	TreeAlias=""
	ListAlias=""

	ActiveGrid=.null.

	Add Object Tree as ContX
	Add Object List as ContX
	Add Object Split as Split

	Procedure Init(m.TreeAlias,m.ListAlias)
	With this
		.CLSID=.Name+".View"
		.Tree.Data.Grid.CLSID=.Name+".Grid.1"
		.List.Data.Grid.CLSID=.Name+".Grid.2"

		.TreeAlias=Iif(Empty(m.TreeAlias),.TreeAlias,m.TreeAlias)
		.ListAlias=Iif(Empty(m.ListAlias),.ListAlias,m.ListAlias)
	
		Select (.TreeAlias)
		.Tree.Data.Grid.RecordSource=.TreeAlias
		.TreeGrid(.Tree.Data.Grid)

		Select (.ListAlias)
		.List.Data.Grid.RecordSource=.ListAlias
		.ListGrid(.List.Data.Grid)

		With .List.Data.Grid
		EndWith
		Local SplitPos
		SplitPos=0
		ReadListPref(.Tree.Data.Grid)
		ReadListPref(.List.Data.Grid)
		ReadWindowPref(this,@SplitPos)
		If not Empty(SplitPos)
			.Split.Left=SplitPos
		EndIf
		.ReSize
	EndWith

	Procedure TreeGrid(oGrid)
	
	Procedure ListGrid(oGrid)

	Procedure ReSize
	With this
		Local LockScreen
		LockScreen=.LockScreen
		.LockScreen=.T.
		
		.Split.Height=.Height+2
		
		.Tree.Top=0
		.Tree.Left=0
		.Tree.Width=.Split.Left-1
		.Tree.Height=.Height+0

		.List.Top=0
		.List.Left=.Split.Left+.Split.Width
		.List.Width=.Width-(.Split.Left+.Split.Width)-1
		.List.Height=.Height+0
		
		.LockScreen=LockScreen
	
	EndWith

	Procedure QueryunLoad
	With this
		SaveListPref(.Tree.Data.Grid)
		SaveListPref(.List.Data.Grid)
		SaveWindowPref(this,.Split.Left)
	EndWith

	Procedure Activate
	ActivateForm(this)

	Procedure DeActivate
	DeActivateForm(this)

	Procedure Destroy
	DeactivateForm(this)

	Procedure Keypress
	LPARAMETERS nKeyCode, nShiftAltCtrl
	with this
		if .Escaped and nKeyCode=27
			if .QueryUnload()
				.Hide
				.Release
				NoDefault
				Return
			endif
		endif
		if nShiftAltCtrl=2 and Inlist(nKeyCode,30,31)
			if nKeyCode=31
				GO TOP
			else
				GO BOTTOM
			endif
		endif
		If nKeyCode=13 ;
			and nShiftAltCtrl=0 ;
			and ThisForm.WindowState # 1
		
			.ParentObject.Open()

		EndIf 


	EndWith
	
	
EndDefine


Define Class DualData as Container
	SpecialEffect=0
	BorderWidth=0
	Top=2
	Left=2

	Alias=""
	
	Add Object Grid as MyGrid with ;
		Top=-1,;
		Left=-1

	Procedure ReSize
	With this
		.Width=.Parent.Width-4
		.Height=.Parent.Height-4
		.Grid.Width=.Width+2
		.Grid.Height=.Height+2
		If .Grid.RecordSource=thisform.treealias
			.Grid.Columns[1].Width=.Grid.Width-2-Sysmetric(5)
		endif
	EndWith

EndDefine


Define Class ContX as Container
	SpecialEffect=1
	Top=0
	Left=0

	Add Object Data as DualData

	Procedure ReSize
	With this
*!*			.Width=.Parent.Width
*!*			.Height=.Parent.Height
		.Data.Width=.Width-2
		.Data.height=.Height-2
	EndWith

EndDefine

Define Class Split as Shape
	Limit=80
	BorderStyle=0
	Top=-1
	Left=120
	Width=3
	MousePointer=99
	MouseIcon=CUR_VSPLIT
	DeltaX=0
	DeltaY=0
	
	Procedure MouseDown(nButton, nShift, nXCoord, nYCoord)
	With this
		If nButton=1
			.Width=.Width+2
			.DrawMode=8
			.DeltaX=.Left-nXCoord
		EndIf
	EndWith
	
	Procedure MouseMove(nButton, nShift, nXCoord, nYCoord)
	With this
		If nButton=1
			If Between(nXCoord,.Limit,ThisForm.Width-.Limit)
				.Left=nXCoord+.DeltaX
			EndIf
		endif
	EndWith
	
	Procedure MouseUp(nButton, nShift, nXCoord, nYCoord)
	With this
		If nButton=1
			.Width=.Width-2
			.DrawMode=13
			thisform.resize
		endif
	EndWith

EndDefine

