*
* 
*

#include include/main.h

External Form INVOICE
ROOT_OBJECT.AddObject("INVOICE","INVOICE")

Define Class INVOICE as MyDocument
	Name="INVOICE"
	Title=''
	Alias='INVOICE'
	FormName='INVOICE'
	ListClsID='INVOICE.View.1'
	ListCaption=' '
	KeyField='DOCID'
	FaceMask=Bitor(FACE_10,FACE_20,FACE_40)
	DocumentOption=[DO InvOptn with (This.Record)]

	Add Object Data as InvoiceData
	
	Procedure Default
	With this.record
		.OwnerID=GetDefault("Common","Owner","")
		.Date=Date()
		.Number=GetNewDocumentNumber(this.alias,this.record)

		.DocType=INV_CASH
		.CashType=TYPE_CASH
		.PriceType=1

	EndWith 
	
	Procedure Tested
	With this
		With .record
			If Empty(.Date)
				MessageBox("   .",64,this.title)
				Return .f.
			EndIf
			If Empty(.Number)
				MessageBox("   .",64,this.title)
				Return .f.
			EndIf
			If Empty(.Name)
				MessageBox("  .",64,this.title)
				Return .f.
			EndIf
			If Empty(.Total)
				MessageBox("  ",64,this.title)
				Return .f.
			EndIf
		EndWith
		If Not CheckDocumentNumber(.Alias,.Record)
			MessageBox("  ",64,.Title)
			Return .f.
		EndIf
	EndWith 

	Procedure Grid(oGrid)
	With oGrid
		.AddColumn(1,'Date','',,'Date')
		.AddColumn(2,'Number','',_PIC_NUMBER,'number')
		.AddColumn(3,'(Name)','',3,'name')
		.AddColumn(4,'Total','',"@Z "+_PIC_TOTAL)
		.Summary='Total'
	EndWith

	Procedure  ShortCutMenu(nColumnIndex)

	Procedure GetData
	With this
		DO DataInvIn in DataIn with (this)
		If Vartype(.Form)="O"
			.Form.List.Requery
			.Calculate()
			.Form.Refresh
		EndIf
	EndWith

	Procedure Calculate
	With This
		With .Record
		EndWith
	EndWith

EndDefine


Define Class InvoiceData as Contents
	Alias="INVDATA"	
	KeyField="DOCID"

	Add Object Item as InvoiceItem

	Procedure Init
	With this
		If not DoDefault()
			Return .F.
		EndIf
	EndWith

	Procedure AlterTable(m.cAlias)
	With this
		Alter Table (m.cAlias) Add Column Name 		m
		Alter Table (m.cAlias) Add Column Unit 		c(10)
		Alter Table (m.cAlias) Add Column oAmount	y
		Alter Table (m.cAlias) Add Column oAmount2	y
	EndWith
	
EndDefine

Define Class InvoiceItem as BaseClass
	ThisDoc=.null.

	Procedure init
	With this
		If Not DoDefault()
			Return .F.
		EndIf
	EndWith

	Procedure Create
	* Nothing
	
	Procedure Load
	With this.Parent
		With .Record
			.Name=Lookup(Item.Name,.ItemID,Item.ItemID,"ITEMID")
			.Unit=Item.Unit
			.Amount=.Amount-.Amount2
		EndWith
	EndWith
	
	Procedure Save
	With this.Parent
		This.InitErrors()
		With .Record
			If Not Empty(.ItemID)
				If Seek(.ItemID,"ITEM","ITEMID")
					.Amount=.Amount+.Amount2
					If not Empty(.Batch) and Not Item.UnLimited
						If Seek(.Batch,"SUPDATA","BATCH")
							If .Amount > SupData.Remainder 
								This.ThisDoc.Errors.Add([  "]+;
									Alltrim(tiem.name)+["  ]+Amount(.Remainder)+;
									[   ]+Amount(.Amount))
								Return .F.
								*  
							Else
								Replace SupData.Remainder with SupData.Remainder-.Amount
							EndIf						
						EndIf
					EndIf
				EndIf
			EndIf
		EndWith
	EndWith

	Procedure Retrieve
	With this.parent
		This.InitErrors()
		With .Record
			If Not Empty(.ItemID)
				If Seek(.ItemID,"ITEM","ITEMID")
					If not Empty(.Batch)
						If Seek(.Batch,"SUPDATA","BATCH")
							If SupData.Remainder+.Amount > SupData.Amount
								This.ThisDoc.Errors.Add([  "]+;
									Alltrim(Item.name)+[" ]+Amount(SupData.Remainder+.Amount)+;
									[     ]+Amount(SupData.Amount))
								Return .F.
								*   
							Else
								Replace SupData.Remainder with SupData.Remainder+.Amount
							EndIf
						EndIf
					EndIf
				EndIf
			EndIf
		EndWith
	EndWith
	
	Procedure Delete
	Return This.Retrieve()

	Procedure InitErrors
	This.thisdoc=this.parent.parent


EndDefine

