*:********************************************************************
*:
*: Procedure file :MRU.PRG
*:
*: (c) Piva, BEAR v.42 on 11.02.2003 16:57
*:********************************************************************
*
*    MRU
*
*
#define MRU_TABLE	"MRU.DBF"

Lparameters m.cField, m.cText
Local x
x=CreateObject("MRU")
DO case
Case Pcount()=1
	x.Get(m.cField)
Case Pcount()=2
	x.Put(m.cField,m.cText)
EndCase 

Return x

*:********************************************************************
*:
*:    Class : MRU based on SESSION
*:
*:********************************************************************
Define Class MRU as Session
	DataSession=2
	Alias=""
	Count=0
	DisplayCount=115
	
	Dimension Values[1]
	
	*:********************************************************************
	*:
	*: Method : INIT of class MRU
	*:
	*:********************************************************************
	Procedure Init
	With this
		Set Deleted On
		Set Exclusive Off
		.Alias=JustStem(MRU_TABLE)
		
		If not File(MRU_TABLE)
			Create Table (MRU_TABLE) free ;
				(Field 	C(20);
				,Text	C(80);
				,Usage	i)
			
		EndIf
		If not Used(.Alias)
			USE (MRU_TABLE) In 0 Alias (.Alias)
		EndIf
	EndWith
	
	*:********************************************************************
	*:
	*: Method : GET of class MRU
	*:
	*:********************************************************************
	Procedure Get( m.cField )
	With this
		Local m.TopCount
		m.TopCount=.DisplayCount
		Select Top (m.TopCount) Text from MRU ;
			where Field=m.cField ;
			order by Usage DESC ;
			into array .Values
		
		.Count=_TALLY
		Return .Count
	EndWith
	
	*:********************************************************************
	*:
	*: Method : PUT of class MRU
	*:
	*:********************************************************************
	Procedure Put(m.cField,m.cText)
	With this
		If not Empty(m.cText)
			Local tmp[1]
			m.cField=Padr(m.cField,Fsize("FIELD",.Alias))
			m.cText=Padr(m.cText,Fsize("TEXT",.Alias))
			
			Select count(*) from (.Alias) ;
				where Field=m.cField ;
				and Text=m.cText ;
				into array tmp
			
			If tmp[1]=0
				Insert into (.Alias) (Field, Text) values (m.cField,m.cText)
			Else
				Update (.Alias) Set Usage=Usage+1 ;
					where Field=m.cField and Text=m.cText 
			EndIf
		EndIf 
	EndWith
	
	*:********************************************************************
	*:
	*: Method : DESTROY of class MRU
	*:
	*:********************************************************************
	Procedure Destroy
	USE in (This.Alias)
	
EndDefine

*: End of MRU.PRG
