*:********************************************************************
*:
*: Procedure file :MRUOBJ.PRG
*:
*: (c) Piva, BEAR v.42 on 11.02.2003 16:56
*:********************************************************************
*
* MRU List
* Emulation of VFP7 MRU list 
*
*  Vadim Pirozhkoff 2001, mailto:piva@kurgan.isp.ru
* 13:13, saturday, october 13, 2001
*
* Using this instead of ComboBox cause ComboBox
* with entering new values have small problems
* to operate it in forms, grids and other controls
* You can store MRU values anywhere you want
*
*
* MRU Listbox makes as non modal window becuse 
* users can click mouse on any desktop area 
*

Lparameters m.Obj, m.cField, m.cText

Local m.oMru, x, i

If Pcount()=3
	Mru(m.cField,m.cText)
	Return 	.T.
EndIf

If _Screen.ActiveForm.DeskTop or _Screen.ActiveForm.ShowWindow=2
	m.oMRU=CreateObject("DeskTopMRU",m.Obj)
Else
	m.oMRU=CreateObject("MRUOBJ",m.Obj)
EndIf

If not Empty(m.cField)
	x=Mru(m.cField)
*!*		For i=1 to Min(x.Count,oMRU.DisplayCount)
*!*			m.oMru.AddItem(Alltrim(x.Values[i]))
*!*		Next
	For i=1 to x.Count
		m.oMru.AddItem(Alltrim(x.Values[i]))
	Next
	m.oMru.Show()
EndIf

Return m.oMru

*:********************************************************************
*:
*:    Class : DESKTOPMRU based on MRUOBJ
*:
*:********************************************************************
Define Class DeskTopMRU as MRUOBJ
	* Class used with DESKTOP and AS TOP LEVEL FORM
	DeskTop=.T.
	ShowWindow=2
EndDefine

*:********************************************************************
*:
*:    Class : MRUOBJ based on FORM
*:
*:********************************************************************
Define Class MRUOBJ as Form
	BorderStyle=2		&& Dialog border
	MinButton=.F.		
	MaxButton=.F.
	TitleBar=0			&& No title bar
	Top=0				
	Left=0
	DisplayCount=15		&& ListBox DisplayCount
	DisplayWidth=0		&& Used by class to determinate list width
	ParentObject=.null.	&& reference to object from where MRU is called
	Self=.null.			&& Self reference 
	Single=.F.
	
	Add Object List as ListBox with ;
		Top=-2,;
		Left=-2,;
		FontName='MS Sans Serif',;
		FontSize=8
	
	*:********************************************************************
	*:
	*: Method : ADDITEM of class MRUOBJ
	*:
	*:********************************************************************
	Procedure AddItem(cItem)
	With this.List
		Local w
		.AddItem(cItem)
		
		* By TXTWIDTH function we can determinate list width
		
		Local w
		w=(Txtwidth(cItem,.FontName,.FontSize,'N')*Fontmetric(6,.FontName,.FontSize,'N'))+2	&& I don't know why ?
		This.DisplayWidth=Max(This.DisplayWidth,w)
	EndWith
	
	*:********************************************************************
	*:
	*: Method : SHOW of class MRUOBJ
	*:
	*:********************************************************************
	Procedure Show( nShow )
	* When the MRU form is shown, calculate form height and width 
	* by listbox count items and id width
	
	With this
		.List.Width=.Width+4
		
		Local listcount, FontHeight
		* Forn Height and 2 pixels add (Why ?)
		FontHeight=Fontmetric(1,.List.FontName,.List.FontSize,"N")+2
		ListCount=.List.ListCount
		
		* If uyou useing pictures you must to add pictures width
		.List.Width=.DisplayWidth+Sysmetric(5)+4
		
		If ListCount > .DisplayCount
			.Height=FontHeight*.DisplayCount
		Else
			* if less that four items in list - scroll bar is non visible
			.Height=FontHeight * ListCount
		EndIf
		If .ParentObject.Width > .List.Width
			.List.Width=.ParentObject.Width
		EndIf
		
		* Remove ListBox Border under window view port
		.List.Height=.Height+4
		.Width=.List.Width-4

		If ListCount <= .DisplayCount
			.List.Width=.List.Width+Sysmetric(5) && Scroll Bar Width
		EndIf
		
		If .Top+.Height > Sysmetric(2)
			.Top=.Top-.Height-.ParentObject.height
		EndIf
		If .Left+.Width > Sysmetric(1)
			.Left=Sysmetric(1)-.Width
		EndIf
		If .Left < 0
			.Left=0
		EndIf
		If .Top < 0
			.Top=0
		EndIf

		.List.SetFocus()		
		DoDefault(nShow)
		
	EndWith
	
	*:********************************************************************
	*:
	*: Method : INIT of class MRUOBJ
	*:
	*:********************************************************************
	Procedure Init( m.Obj )
	With this
		Local oForm
		oForm=_Screen.ActiveForm
		
		* Determinate form location of object parent form
		* Top is a Top of Object Form + Object height + Object Coordinate
		.Top=oForm.Top+m.Obj.Height+Objtoclient(m.Obj,1)
		.Left=oForm.Left+Objtoclient(m.Obj,2)
		
		* Adjustment of a border width
		DO Case
		Case oForm.BorderStyle=0
		Case oForm.BorderStyle=1
			.Top=.Top+Sysmetric(11)
			.Left=.Left+Sysmetric(10)
		Case oForm.BorderStyle=2
			.Top=.Top+Sysmetric(11)
			.Left=.Left+Sysmetric(10)
		Case oForm.BorderStyle=3
			.Top=.Top+Sysmetric(4)
			.Left=.Left+Sysmetric(3)
		EndCase
		
		* If Top Form have a title bar
		If oForm.TitleBar=1
			* If that Title bar is HalfHeight
			If .HalfheightCaption
				.Top=.Top+Sysmetric(34)
			Else
				.Top=.Top+Sysmetric(9)
			EndIf
		EndIf
		
		.Self=this
		.ParentObject=m.obj
		
		* We must trap mouse click to determinate 
		* location of mouse click - is that window MRU 
		* if other than MRU, Menu, StatusBar of DeskTop
		* MRU must be deactivated
		
		on key label leftmouse ;
			iif(type('_screen.activeform')='O' and pemstatus(_screen.activeform,'onmouse',5),;
			_screen.activeform.onmouse(),.f.)
		
	EndWith
	
	*:********************************************************************
	*:
	*: Method : ONMOUSE of class MRUOBJ
	*:
	*:********************************************************************
	Procedure OnMouse
	local array tmp[1]
	AMouseObj(tmp)
	
	if vartype(tmp[2])='O' and Compobj(tmp[2],this)
		* Click in MRU window
	else
		This.Hide()
		This.Release
	endif
	
	*:********************************************************************
	*:
	*: Method : DEACTIVATE of class MRUOBJ
	*:
	*:********************************************************************
	Procedure Deactivate
	With this
		.Hide()
		.Release
	EndWith

	Procedure LostFocus
	With this
		.Hide()
		.Release
	EndWith
	
	
	*:********************************************************************
	*:
	*: Method : UNLOAD of class MRUOBJ
	*:
	*:********************************************************************
	Procedure UnLoad
	* Restore Mouse trap
	On Key Label LeftMouse
	
	*:********************************************************************
	*:
	*: Method : LIST.DBLCLICK of class MRUOBJ
	*:
	*:********************************************************************
	Procedure List.DblClick
	With this.Parent 
		.Selection(.List.Value)
		.Hide()
		.Release
	EndWith
	
	*:********************************************************************
	*:
	*: Method : LIST.CLICK of class MRUOBJ
	*:
	*:********************************************************************
	Procedure List.Click
	With this.Parent 
		If .Single
			.Selection(.List.Value)
			.Hide()
			.Release
		EndIf 
	EndWith
	
	*:********************************************************************
	*:
	*: Method : SELECTION of class MRUOBJ
	*:
	*:********************************************************************
	Procedure Selection( cValue )
	*Event of MRU list selection
	With this
		DO case
		Case Vartype(.ParentObject.Value)='C'
			.ParentObject.Value=cValue	
		Case Vartype(.ParentObject.Value)='D'
			.ParentObject.Value=Ctod(cValue)
		Case Vartype(.ParentObject.Value)='N'
			.ParentObject.Value=Val(cValue	)
		EndCase			
	EndWith
	
	*:********************************************************************
	*:
	*: Method : KEYPRESS of class MRUOBJ
	*:
	*:********************************************************************
	Procedure KeyPress(nKey, nShift)
	If nKey=27
		With this
			.Hide()
			.Release()
		EndWith
	EndIf
	
EndDefine

*: End of MRUOBJ.PRG
