*
* 
*

#include include/main.h

External Form SUPPLY
ROOT_OBJECT.AddObject("SUPPLY","SUPPLY")


Define Class SUPPLY as MyDocument
	Name="SUPPLY"
	Title=''
	Alias='SUPPLY'
	FormName='SUPPLY'
	ListClsID='SUPPLY.View.1'
	ListCaption=' '
	KeyField='DOCID'
	FaceMask=Bitor(FACE_10,FACE_20,FACE_40)
	DocumentOption=[DO SupOptn with (This.Record)]


	Add Object data as SupplyData

	
	Procedure Default
	With this.record
		.OwnerID=GetDefault("Common","Owner","")
		.Date=Date()
		.Number=GetNewDocumentNumber(this.alias,this.record)

		.DocType=SUP_SUPPLY
		.CashType=TYPE_BANK
	
	EndWith 
	
	Procedure Tested
	With this.record
		If Empty(.Date)
			MessageBox("   .",64,this.title)
			Return .f.
		EndIf
		If Empty(.Name)
			MessageBox("  .",64,this.title)
			Return .f.
		EndIf
		If Empty(.Total)
			MessageBox("  ",64,this.title)
			Return .f.
		EndIf

		If .DocType=SUP_RESERVED
			If Not CanSupplyBeReserved(.DocID)
				MessageBox("    ,      ",64,thisForm.Caption)
				Return .F.
			EndIf
		EndIf
	EndWith 

	Procedure Grid(oGrid)
	With oGrid
		.AddColumn(1,'Date','',,'Date')
		.AddColumn(2,'Number','',_PIC_NUMBER,'number')
		.AddColumn(3,'(Name)','',3,'name')
		.AddColumn(4,'Total','',_PIC_TOTAL)

		.Summary='Total'

		.SetAll("DynamicForeColor","PaintSupply(This.ForeColor)","MyColumn")

	EndWith

	Procedure ShortCutMenu(nColumnIndex)

	Procedure GetData
	With this
		DO DataSupIn in DataIn with (this)
		If Vartype(.Form)="O"
			.Form.List.Requery
			.Calculate()
			.Form.Refresh
		EndIf
	EndWith

	Procedure Calculate
	With This
		With .Record
*!*				If Not Empty(.Tax)
*!*					.TaxSum=Round(.Total*.Tax/(100+.Tax),_Tax_Round)
*!*				EndIf
*!*				If Not Empty(.Nds)
*!*					.NdsSum=Round((.Total-.TaxSum)*.Nds/(100+.Nds),_Tax_Round)
*!*				EndIf
*!*				.Summa=.Total-.TaxSum-.NdsSum
		EndWith
	EndWith

EndDefine


Define Class SupplyData as Contents
	Alias="SUPDATA"	
	KeyField="DOCID"

	Add Object Item as SupplyItem

	Procedure AlterTable(m.cAlias)
	With this
		Alter Table (m.cAlias) Add Column Name 		m
		Alter Table (m.cAlias) Add Column Unit 		c(10)
		Alter Table (m.cAlias) Add Column OAmount 	y

	EndWith

	
EndDefine

Define Class SupplyItem as BaseClass
	ThisDoc=.null.
	*    

	Procedure Init
	With this
		If Not DoDefault()
			Return .F.
		EndIf
	EndWith

	Procedure Create
	* Nothing
	
	Procedure Load
	With this.Parent
		With .Record
			.Name=Lookup(Item.Name,.ItemID,Item.ItemID,"ITEMID")
			.Unit=Item.Unit
			.OAmount=Amount
		EndWith
	EndWith
	
	Procedure Save
	With this.Parent
		This.InitErrors()
		With .Record
			If Not Empty(.ItemID)
				If Seek(.ItemID,"ITEM","ITEMID")
					If not Item.UnLimited 
						If not Empty(.Batch)
							.Remainder=.Amount-GetBatchSales(.Batch)
							If .Amount < .Remainder
								This.ThisDoc.Errors.Add([   "]+Alltrim(item.name)+[" ]+;
									Amount(.Amount)+[    ]+Amount(.Remainder))
								Return .F.
							EndIf
						Else
							.Remainder=.Amount
							.Batch=NewBatch()
						EndIf
					EndIf
				EndIf
			EndIf
		EndWith
	EndWith

	Procedure Retrieve
	With this.parent
		This.InitErrors()
		With .Record
			If Not Empty(.ItemID)
				If Seek(.ItemID,"ITEM","ITEMID")
					If not Empty(.Batch)
					EndIf
				EndIf
			EndIf
		EndWith
	EndWith
	
	Procedure Delete
	With this.parent
		This.InitErrors()
		With .Record
			If Not Empty(.ItemID)
				If Seek(.ItemID,"ITEM","ITEMID")
					If not Empty(.Batch)
						m.Amount=GetBatchSales(m.batch)
						If m.amount > 0
							This.ThisDoc.Errors.Add([  "]+Alltrim(item.name)+[" ]+;
								Amount(m.Amount)+[      ])
							Return .F.
						EndIf
					EndIf
				EndIf
			EndIf
		EndWith
	EndWith

	Procedure InitErrors
	This.thisdoc=this.parent.parent

EndDefine

Procedure PaintSupply(ForeColor)
DO Case
Case Archive or DocType=SUP_REST
	Return Rgb(192,192,192)
Case DocType=SUP_RESERVED
	Return Rgb(0,128,0)
Otherwise
	Return ForeColor
EndCase

